import { ExcecuteOperationResult, ExecuteOperation } from 'executable-openapi-types';
import { OperationExecutionRequestBuilder } from './request';
export declare class OperationExecutionAgent<TExecutionContext> extends OperationExecutionRequestBuilder implements Promise<ExcecuteOperationResult> {
    private readonly execute;
    private maybeExecutionResult?;
    private executionContext?;
    constructor(execute: ExecuteOperation<TExecutionContext>);
    [Symbol.toStringTag]: string;
    end(): Promise<ExcecuteOperationResult>;
    context(ctx: TExecutionContext): this;
    then<TResult1 = ExcecuteOperationResult, TResult2 = never>(onfulfilled?: ((value: ExcecuteOperationResult) => TResult1 | PromiseLike<TResult1>) | null, onrejected?: ((reason: any) => TResult2 | PromiseLike<TResult2>) | null): Promise<TResult1 | TResult2>;
    catch<TResult = never>(onrejected?: ((reason: any) => TResult | PromiseLike<TResult>) | null): Promise<ExcecuteOperationResult | TResult>;
    finally(onfinally?: (() => void) | null): Promise<ExcecuteOperationResult>;
}
